package com.zipcodewilmington;
import java.util.ArrayList;
import java.util.Arrays;
/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {

        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */


    public static String getSecondElement(String[] array) {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {

        int i = array.length - 1;

        return array[i];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        int i = array.length - 2;
        return array[i];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {

        for (String s : array)
            if (s.equals(value)) {
                return true;
            }
        return false;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String reverseString[] = new String[array.length];
        int j = 0;
        for (int i = array.length - 1; i >= 0; i--) {
            String revWords = array[i];
            reverseString[j] = revWords;
            j++;
        }
        return reverseString;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        String[] checkArray = reverse(array);
        boolean look = false;
        for (int i = 0; i < array.length - 1; i++) {
            if (checkArray[i] == array[i]) {
                look = true;
            } else {
                look = false;
            }
        }
        return look;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        boolean check = false;
        StringBuilder sb = new StringBuilder();
        int i = 0;
        for (i = 0; i < array.length; i++) {
            sb.append(array[i]);
            String newString = sb.toString().toLowerCase();
            for (char ch = 'a'; ch <= 'z'; ch++) {
                if (newString.indexOf(ch) == -1) {
                    check = false;
                } else {
                    check = true;
                }

            }

        }
        return check;
    }


    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int counter = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i] == value) {
                counter++;
            }
        }
        return counter;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
                /* StringBuilder sb = new StringBuilder();
                 for (int i = 0; i < array.length; i++) {
                if (array[i] != valueToRemove) {
                sb.append(array[i]);
                String goodString = sb.toString();
                 String bestArray[ ] = goodString.split(" ");
                */
        ArrayList<String> newArray = new ArrayList<String>();
        int i = 0;
        while (i < array.length) {
            if ((array[i]).equals(valueToRemove)) {
                i++;
            } else {
                newArray.add(array[i]);
                i++;
            }
        }
        int s = newArray.size();
        String newerArray[] = new String[s];
        newArray.toArray(newerArray);
        return newerArray;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        ArrayList<String> dups = new ArrayList<String>();
        int i = 0;
        while (i < array.length) {
            if ((i + 1 < array.length) && array[i].equals(array[i + 1])) {
                i++;
            } else {
                dups.add(array[i]);
                i++;
            }
        }
        int size = dups.size();
        String duplicatesList[] = new String[size];
        dups.toArray(duplicatesList);
        return duplicatesList;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        int i = 0;
        ArrayList<String> dups = new ArrayList<String>();
        while (i < array.length) {
            if (i > 0 && array[i].equals(array[i - 1])) {
                String holder = dups.get(dups.size() - 1);
                holder += array[i];
                dups.set((dups.size() - 1), holder);
                i++;
            } else {
                dups.add(array[i]);
                i++;
            }
        }
        int size = dups.size();
        String packList[] = new String[size];
        dups.toArray(packList);
        return packList;
    }

}








